diff --git a/drivers/sound/sound.c b/drivers/sound/sound.c
index 4c74534..3a845c9 100644
--- a/drivers/sound/sound.c
+++ b/drivers/sound/sound.c
@@ -24,6 +24,8 @@
 #include <malloc.h>
 #include <common.h>
 #include <asm/io.h>
+#include <libfdt.h>
+#include <fdtdec.h>
 #include <i2c.h>
 #include <i2s.h>
 #include <sound.h>
@@ -37,12 +39,225 @@
 static struct i2stx_info g_i2stx_pri;
 static struct sound_codec_info g_codec_info;
 
+
+#ifdef CONFIG_OF_CONTROL
 /*
- * get_sound_fdt_values gets fdt values for i2s parameters
+ * get_sound_i2s_fdt_values gets fdt values for i2s parameters
  *
  * @param i2stx_info	i2s transmitter transfer param structure
  * @param blob		FDT blob
  */
+static int get_sound_i2s_fdt_values(struct i2stx_info *i2s, const void *blob)
+{
+	int node;
+	int error = 0;
+	int base;
+
+	node = fdtdec_next_compatible(blob, 0,
+					COMPAT_SAMSUNG_EXYNOS5_SOUND);
+	if (node <= 0) {
+		debug("EXYNOS_SOUND: No node for sound in device tree\n");
+		return -1;
+	}
+
+	/*
+	 * Get the pre-defined sound specific values from FDT.
+	 * All of these are expected to be correct otherwise
+	 * wrong register values in i2s setup parameters
+	 * may result in no sound play.
+	 */
+	base = fdtdec_get_addr(blob, node, "reg");
+	if (base == FDT_ADDR_T_NONE) {
+		debug("%s: Missing  i2s base\n", __func__);
+		return -1;
+	}
+	i2s->base_address = base;
+
+	i2s->audio_pll_clk = fdtdec_get_int(blob,
+				node, "samsung,i2s-epll-clock-frequency", -1);
+	error |= i2s->audio_pll_clk;
+	debug("audio_pll_clk = %d\n", i2s->audio_pll_clk);
+	i2s->samplingrate = fdtdec_get_int(blob,
+				node, "samsung,i2s-sampling-rate", -1);
+	error |= i2s->samplingrate;
+	debug("samplingrate = %d\n", i2s->samplingrate);
+	i2s->bitspersample = fdtdec_get_int(blob,
+				node, "samsung,i2s-bits-per-sample", -1);
+	error |= i2s->bitspersample;
+	debug("bitspersample = %d\n", i2s->bitspersample);
+	i2s->channels = fdtdec_get_int(blob,
+			node, "samsung,i2s-channels", -1);
+	error |= i2s->channels;
+	debug("channels = %d\n", i2s->channels);
+	i2s->rfs = fdtdec_get_int(blob,
+				node, "samsung,i2s-lr-clk-framesize", -1);
+	error |= i2s->rfs;
+	debug("rfs = %d\n", i2s->rfs);
+	i2s->bfs = fdtdec_get_int(blob,
+				node, "samsung,i2s-bit-clk-framesize", -1);
+	error |= i2s->bfs;
+	debug("bfs = %d\n", i2s->bfs);
+	if (error == -1) {
+		debug("fail to get sound i2s node properties\n");
+		return -1;
+	}
+
+	return 0;
+}
+
+/*
+ * Gets fdt values for wm8994 config parameters
+ *
+ * @param pcodec_info	codec information structure
+ * @param blob		FDT blob
+ * @return		int value, 0 for success
+ */
+static int get_sound_fdt_values(struct sound_codec_info *pcodec_info,
+			const void *blob, enum fdt_compat_id compat_id)
+{
+	enum fdt_compat_id compat;
+	int node;
+	int error = 0;
+	int parent;
+
+	/* Get the node from FDT for codec */
+	node = fdtdec_next_compatible(blob, 0, compat_id);
+	if (node <= 0) {
+		debug("EXYNOS_SOUND: No node for codec in device tree\n");
+		debug("node = %d\n", node);
+		return -1;
+	}
+
+	parent = fdt_parent_offset(blob, node);
+	if (parent < 0) {
+		debug("%s: Cannot find node parent\n", __func__);
+		return -1;
+	}
+
+	compat = fdtdec_lookup(blob, parent);
+	switch (compat) {
+	case COMPAT_SAMSUNG_EXYNOS_SPI:
+		debug("%s: Support not added for SPI interface\n", __func__);
+		return -1;
+		break;
+	case COMPAT_SAMSUNG_S3C2440_I2C:
+		pcodec_info->i2c_bus = i2c_get_bus_num_fdt(blob, parent);
+		error |= pcodec_info->i2c_bus;
+		debug("i2c bus = %d\n", pcodec_info->i2c_bus);
+		pcodec_info->i2c_dev_addr = fdtdec_get_int(blob, node,
+								"reg", 0);
+		error |= pcodec_info->i2c_dev_addr;
+		debug("i2c dev addr = %d\n", pcodec_info->i2c_dev_addr);
+		break;
+	default:
+		debug("%s: Unknown compat id %d\n", __func__, compat);
+		return -1;
+	}
+
+	if (error == -1) {
+		debug("fail to get codec node properties\n");
+		return -1;
+	}
+
+	return 0;
+}
+
+/*
+ * Gets fdt values for codec config parameters
+ *
+ * @param pcodec_info   codec information structure
+ * @param blob          FDT blob
+ * @return              int value, 0 for success
+ */
+static int get_sound_codec_fdt_values(struct sound_codec_info *pcodec_info,
+							const void *blob)
+{
+	int node;
+	int error = 0;
+	const char *codectype;
+
+	/* Get the node from FDT for sound */
+	node = fdtdec_next_compatible(blob, 0, COMPAT_SAMSUNG_EXYNOS5_SOUND);
+	if (node <= 0) {
+		debug("EXYNOS_SOUND: No node for sound in device tree\n");
+		debug("node = %d\n", node);
+		return -1;
+	}
+
+	/*
+	 * Get the pre-defined sound codec specific values from FDT.
+	 * All of these are expected to be correct otherwise sound
+	 * can not be played
+	 */
+	codectype = fdt_getprop(blob, node, "samsung,codec-type", NULL);
+	debug("device = %s\n", codectype);
+
+	if (!strcmp(codectype, "wm8994")) {
+		pcodec_info->codec_type = CODEC_WM_8994;
+		error = get_sound_fdt_values(pcodec_info, blob,
+						COMPAT_WOLFSON_WM8994_CODEC);
+	} else {
+		error = -1;
+	}
+
+	if (error == -1) {
+		debug("fail to get sound codec node properties\n");
+		return -1;
+	}
+
+	return 0;
+}
+
+int sound_init(const void *blob)
+{
+	int ret;
+	struct i2stx_info *pi2s_tx = &g_i2stx_pri;
+	struct sound_codec_info *pcodec_info = &g_codec_info;
+
+	/* Get the I2S Values */
+	if (get_sound_i2s_fdt_values(pi2s_tx, blob) < 0) {
+		debug(" FDT I2S values failed\n");
+		return -1;
+	}
+
+	/* Get the codec Values */
+	if (get_sound_codec_fdt_values(pcodec_info, blob) < 0) {
+		debug("FDT Codec values failed\n");
+		return -1;
+	}
+
+	ret = i2s_tx_init(pi2s_tx);
+	if (ret) {
+		debug("%s: Failed to init i2c transmit: ret=%d\n", __func__,
+		      ret);
+		return ret;
+	}
+
+	/* Check the codec type and initialise the same */
+	if (pcodec_info->codec_type == CODEC_WM_8994) {
+		ret = wm8994_init(pcodec_info, WM8994_AIF2,
+			pi2s_tx->samplingrate,
+			(pi2s_tx->samplingrate * (pi2s_tx->rfs)),
+			pi2s_tx->bitspersample, pi2s_tx->channels);
+	} else {
+		debug("%s: Unknown code type %d\n", __func__,
+		      pcodec_info->codec_type);
+		return -1;
+	}
+	if (ret) {
+		debug("%s: Codec init failed\n", __func__);
+		return -1;
+	}
+
+	return ret;
+}
+
+#else
+/*
+ * get_sound_values gets values for i2s parameters
+ *
+ * @param i2stx_info	i2s transmitter transfer param structure
+ */
 static void get_sound_i2s_values(struct i2stx_info *i2s)
 {
 	i2s->base_address = samsung_get_base_i2s();
@@ -55,13 +270,12 @@ static void get_sound_i2s_values(struct i2stx_info *i2s)
 }
 
 /*
- * Gets fdt values for wm8994 config parameters
+ * Gets values for wm8994 config parameters
  *
  * @param pcodec_info	codec information structure
- * @param blob		FDT blob
  * @return		int value, 0 for success
  */
-static int get_sound_wm8994_values(struct sound_codec_info *pcodec_info)
+static int get_sound_values(struct sound_codec_info *pcodec_info)
 {
 	int error = 0;
 
@@ -89,10 +303,9 @@ static int get_sound_wm8994_values(struct sound_codec_info *pcodec_info)
 }
 
 /*
- * Gets fdt values for codec config parameters
+ * Gets values for codec config parameters
  *
  * @param pcodec_info	codec information structure
- * @param blob		FDT blob
  * @return		int value, 0 for success
  */
 static int get_sound_codec_values(struct sound_codec_info *pcodec_info)
@@ -104,7 +317,7 @@ static int get_sound_codec_values(struct sound_codec_info *pcodec_info)
 
 	if (!strcmp(codectype, "wm8994")) {
 		pcodec_info->codec_type = CODEC_WM_8994;
-		error = get_sound_wm8994_values(pcodec_info);
+		error = get_sound_values(pcodec_info);
 	} else {
 		error = -1;
 	}
@@ -155,6 +368,7 @@ int sound_init(void)
 
 	return ret;
 }
+#endif
 
 /*
  * Generates square wave sound data for 1 second
diff --git a/include/sound.h b/include/sound.h
index ea0b115..aeb70ee 100644
--- a/include/sound.h
+++ b/include/sound.h
@@ -44,12 +44,21 @@ struct sound_codec_info {
 	enum en_sound_codec codec_type;
 };
 
+#ifdef CONFIG_OF_CONTROL
+/*
+ * Initialises audio sub system
+ * @param blob	Pointer of device tree node.
+ * @return	int value 0 for success, -1 for error
+ */
+int sound_init(const void *blob);
+#else
 /*
  * Initialises audio sub system
  *
  * @return	int value 0 for success, -1 for error
  */
 int sound_init(void);
+#endif
 
 /*
  * plays the pcm data buffer in pcm_data.h through i2s1 to make the